global gHavok, kForward, kBackward, kRight, kLeft, SndC_Music, SndC_Grnd, SndC_FX1, SndC_FX2, SndC_Engine, SndC_EnemyFX, SndC_VO, gGameMODE, gTextures, gOverlays, g3DWorld, mCamera, _PI, _PI2, _PI180, _180PI, myBytesLoaded, myBytesTotal, gLevel, gUserString, gUserEmail, gRunMode, gScore, myStreamState, gCurrentCar, mSpinnerScene, ovSpinner, gCurrentRim, gPlayMode, gCurrentCarID, gScoresURL, gChallengeURL, gCarName, gPlayerKeysList, gNewGame, gPlayer_1_Total_Score, gPlayer_1_Event1_Score, gPlayer_1_Event2_Score, gPlayer_1_Event3_Score, gPlayer_2_Total_Score, gPlayer_2_Event1_Score, gPlayer_2_Event2_Score, gPlayer_2_Event3_Score, gEventID, gScoresList, gBestScoresList, gPassedScore

on doPlaySound mySound
  SndC_FX1.play(member(mySound))
end

on doSeeToys me
  gotoNetPage("/showcase/category_brand_product.aspx?category_id=7581")
end

on doScoreBoard myScore, me
  gPassedScore = myScore
  put "doScoreBoard() : myScore = " & myScore
  go("SCOREBOARD")
end

on doHideScoreBoard me
  gPassedScore = 0
  go("MAIN")
end

on doSendtoFriend me
  go("SENDMAIL")
end

on doHideSendtoFriend me
  go("MAIN")
end

on doRestart me
  go("HS")
end

on doStartEvent carName, key_p1_accel, key_p1_boost, key_p2_accel, key_p2_boost, theplayMode
  gNewGame = 0
  SndC_Music.fadeOut(1000)
  gCarName = carName
  gPlayerKeysList = [key_p1_accel, key_p1_boost, key_p2_accel, key_p2_boost]
  gGameMODE = theplayMode
  if gCarName = "Dragster" then
    gEventID = 1
  else
    if gCarName = "Jumper" then
      gEventID = 3
    else
      if gCarName = "Rocket" then
        gEventID = 2
      else
        gEventID = 0
      end if
    end if
  end if
  gScoresList[gEventID] = [0, 0]
  go("PREP")
end

on doStartGame me
  gNewGame = 1
  gScoresList = [[0, 0], [0, 0], [0, 0]]
  gBestScoresList = [[0, 0], [0, 0], [0, 0]]
  gPassedScore = 0
end

on doWelcome me
  go("WELCOME")
end

on streamStatus url, state, bytesSoFar, bytesTotal, error
  myStreamState = state
  myBytesLoaded = bytesSoFar
  myBytesTotal = bytesTotal
end

on prepareMovie me
  exitLock = 1
  gNewGame = 1
  tellStreamStatus(1)
  the romanLingo = 1
  gGameMODE = 0
  kForward = 126
  kBackward = 125
  kRight = 124
  kLeft = 123
  _PI = PI
  _PI2 = 0.5 * PI
  _180PI = 180.0 / PI
  _PI180 = PI / 180
  gRunMode = the runMode
  SndC_Music = sound(1)
  SndC_Grnd = sound(2)
  SndC_FX1 = sound(3)
  SndC_FX2 = sound(4)
  SndC_Engine = sound(5)
  SndC_EnemyFX = sound(6)
  SndC_VO = sound(7)
end

on startMovie
  the allowSaveLocal = 0
  if not validDomain() and (gRunMode <> "Author") then
  end if
  gCarName = "Dragster"
  gGameMODE = 2
end

on validDomain
  num = externalParamCount()
  if externalParamValue("src") starts "http:" then
    return 0
  end if
  validDomains = ["blitinteractive.com", "blitgames.net"]
  repeat with sDomain in validDomains
    if the moviePath contains sDomain then
      return 1
    end if
  end repeat
  return 0
end

on createTexture tName, tmember, tRenderFormat, tFiltering, tQuality
  put tName & ", " & tmember
  T = g3DWorld.newTexture(tName, #fromCastMember, member(tmember))
  T.renderFormat = tRenderFormat
  T.nearFiltering = tFiltering
  T.quality = tQuality
  gTextures.addProp(tName, T)
  return T
end

on createOverlay tCam, tName, tmember, tRenderFormat, tFiltering, tQuality, tBlend, tPos, tRot
  if not g3DWorld.texture(tName) then
    T = createTexture(tName, tmember, tRenderFormat, tFiltering, tQuality)
  else
    T = g3DWorld.texture(tName)
  end if
  tCam.addOverlay(T, tPos, tRot)
  t1 = tCam.overlay.count
  tCam.overlay[t1].blend = tBlend
  gOverlays.addProp(tName, t1)
  return t1
end

on createBackdrop tCam, tName, tmember, tRenderFormat, tFiltering, tQuality, tBlend, tPos, tRot
  if not g3DWorld.texture(tName) then
    T = createTexture(tName, tmember, tRenderFormat, tFiltering, tQuality)
  else
    T = g3DWorld.texture(tName)
  end if
  tCam.addBackdrop(T, tPos, tRot)
  t1 = tCam.backdrop.count
  tCam.backdrop[t1].blend = tBlend
  return t1
end

on getRotStep rot, goto_rot, stepFactor
  if rot > 180 then
    rot = rot - 360
  end if
  if rot >= goto_rot then
    stepNeg = rot - goto_rot
    stepPos = 360 - stepNeg
  else
    if goto_rot > rot then
      stepPos = goto_rot - rot
      stepNeg = 360 - stepPos
    end if
  end if
  if stepNeg < stepPos then
    step = stepNeg * -stepFactor
  else
    step = stepPos * stepFactor
  end if
  return step
end

on ceil f
  int = integer(f)
  if int = f then
    return int
  else
    if f > 0 then
      return integer(f + 0.5)
    else
      return integer(f - 0.5)
    end if
  end if
end

on floor f
  int = integer(f)
  if int = f then
    return int
  else
    if f > 0 then
      return integer(f - 0.5)
    else
      return integer(f + 0.5)
    end if
  end if
end

on getAngle x1, y1, x2, y2
  xoff = x2 - x1
  yoff = y2 - y1
  if xoff > 0 then
    tAngle = 90 - (atan(yoff / xoff) * _180PI)
  else
    if (xoff = 0) and (yoff >= 0) then
      tAngle = 0
    else
      if (xoff = 0) and (yoff < 0) then
        tAngle = 180
      else
        if xoff < 0 then
          tAngle = -90 - (atan(yoff / xoff) * _180PI)
        end if
      end if
    end if
  end if
  return tAngle
end

on normalizeAngle a
  if a < 0 then
    a = 360.0 + a
  end if
  a = a mod 360.0
  return a
end
